<?php
namespace Pedidos\Logic;
use \Geral\Entities\Pedido;
use \Geral\Util\TratamentoDeMensagens;
use \Pedidos\Entities\Reserprodped;
use \Geral\Entities\Parampedido;
use \Geral\Entities\Paramfilial;
use \Geral\Entities\Prodfili;
use \Geral\Entities\Produto;
use \Geral\Util\NovoCodigo;
use \Geral\Util\DateUtil;
use \Geral\Util\Ambiente;
use \Setforms2\Shared\Registry;

class ReservaItem{

	//Rotina de Reserva
	public static function reservaItemPed($nrorg, $cdfilial, $nrpedido, $nritemped, $cdproduto, $qtitemped){

		//Busca Parametros de Pedido de Vendas
		$parampedido = Parampedido::findOneByCdfilialAndNrorg($cdfilial,$nrorg);
		if($parampedido){
		
			//Verifica Parametro de Reserva do Produto
			if($parampedido->getIdutreselote() == 'S'){

				//Busca Produto e Verifica Produto de Estoque
				$produto = Produto::findOneByNrorgAndCdproduto($nrorg, $cdproduto);
				if($produto){
					$vrfatoconv = 1;
					if(($cdproduto <> $produto->getCdprodesto())&&($produto->getCdprodesto() <> NULL)){
						//Verifica Fator de Convercao
						if($produto->getVrfatoconv() <> NULL){
							//Calcula Quantidade baseada no Fator de Convercao
							$vrfatoconv = $produto->getVrfatoconv();
							$qtitemped = $qtitemped * $vrfatoconv;
						}
						//Busca Produto de Estoque
						$produto = Produto::findOneByCdprodutoAndNrorg($produto->getCdprodesto(), $nrorg);
					}
					$cdproduto = $produto->getCdproduto();
				}
				
				//Busca Produto por Filial e Verifica Controle de Estoque
				$prodfili = Prodfili::findOneByNrorgAndCdfilialAndCdproduto($nrorg, $cdfilial, $cdproduto);
                if($prodfili){
                    if($prodfili->getIdcntrestoq() == 'S'){
                        //Busca Reservas do Produto
                        $reserprodped = Reserprodped::findByNrorgAndCdfilialAndNrpedidoAndNritemped($nrorg, $cdfilial, $nrpedido, $nritemped);
                        if($reserprodped){
                            //Exclusão Reservas Existentes
                            foreach ($reserprodped as $reserprod) {
                                $reserprod->delete();
                            }
                            Registry::getEntityManager()->flush();
                        }

                        //Verifica Teste de Estoque
                        if($parampedido->getIdtestaest() == '2'){
                            $testaest = TRUE;
                        }else $testaest = FALSE;

                        //Busco Parametrizacao de Filial
                        $paramfilial  = Paramfilial::findOneByNrorgAndCdfilial($nrorg, $cdfilial);

                        //Verifica Controle de Almoxarifado
                        if($paramfilial->getIdutilalmox() == 'S'){
                            if($prodfili->getCdalmoxprcli() <> NULL){
                                //Verifica Controle de Local de Estoque
                                if($paramfilial->getIdutillcestq() == 'S'){
                                    if($prodfili->getCdlocalprcli() <> NULL){
                                        //Verifica Controle de Lote
                                        if($paramfilial->getIdutillote() == 'S'){
                                            //Reserva PRODUTO COM Controle de Almoxarifado, Local e Lote.
                                            $qtdedisp = ReservaItem::retornaQtdeDisp($cdfilial, $cdproduto, $prodfili->getCdalmoxprcli(), $prodfili->getCdlocalprcli());
                                            $resp = ReservaItem::reserProd($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtdedisp, $qtitemped, $testaest, $vrfatoconv);
                                            return $resp;
                                        }else{
                                            //Reserva PRODUTO COM Controle de Almoxarifado e Local, mas sem Lote.
                                            $qtdedisp = ReservaItem::retornaQtdeDisp($cdfilial, $cdproduto, $prodfili->getCdalmoxprcli(), $prodfili->getCdlocalprcli(), ' ', ' ');
                                            $resp = ReservaItem::reserProd($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtdedisp, $qtitemped, $testaest, $vrfatoconv);
                                            return $resp;
                                        }
                                    }else return 'Localização de Reserva não Parametrizada no Local de Estoque por Produto.';
                                }else{
                                    //Verifica Controle de Lote
                                    if($paramfilial->getIdutillote() == 'S'){
                                        //Reserva Produto COM Controle de Almoxarifado e Lote, mas sem Local.
                                        $qtdedisp = ReservaItem::retornaQtdeDisp($cdfilial, $cdproduto, $prodfili->getCdalmoxprcli(), ' ');
                                        $resp = ReservaItem::reserProd($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtdedisp, $qtitemped, $testaest, $vrfatoconv);
                                        return $resp;
                                    }else{
                                        //Reserva PRODUTO COM Controle de Almoxarifado, mas sem Local e Lote.
                                        $qtdedisp = ReservaItem::retornaQtdeDisp($cdfilial, $cdproduto, $prodfili->getCdalmoxprcli(), ' ', ' ', ' ');
                                        $resp = ReservaItem::reserProd($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtdedisp, $qtitemped, $testaest, $vrfatoconv);
                                        return $resp;
                                    }
                                }
                            }else return 'Almoxarifado de Reserva não Parametrizado no Local de Estoque por Produto.';
                        }else{
                            //Verifica Controle de Lote
                            if($paramfilial->getIdutillote() == 'S'){
                                //Reserva Produto SEM Controle de Almoxarifado e Local, mas com Lote.
                                $qtdedisp = ReservaItem::retornaQtdeDisp($cdfilial, $cdproduto, ' ', ' ');
                                $resp = ReservaItem::reserProd($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtdedisp, $qtitemped, $testaest, $vrfatoconv);
                                return $resp;
                            }else{
                                //Reserva Produto SEM Controle de Almoxarifado, Local e Lote.
                                $qtdedisp = ReservaItem::retornaQtdeDisp($cdfilial, $cdproduto, ' ', ' ', ' ', ' ');
                                $resp = ReservaItem::reserProd($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtdedisp, $qtitemped, $testaest, $vrfatoconv);
                                return $resp;
                            }
                        }
                    }
                }else return 'Produto não Parametrizado para Filial.';
			}
		}else return 'Filial não possui Parametrização de Pedido de Vendas.';
	}

	//Novo Codigo para Reserva do Item
	public static function novoCodigoReserva($nrorg, $cdfilial){
        try{
			$aux    = 'NRRESPRODPED'.$cdfilial;
            $codigo = NovoCodigo::geraCodigo($nrorg,$aux,1,10, false);
            return $codigo;
		}catch(\Exception $e){
            TratamentoDeMensagens::exibirMensagens($e);
        }
    }
	
	//Executa Select do Repository QtdeDisp
	public function retornaQtdeDisp($cdfilial, $cdproduto, $cdalmoxarife, $cdlocalestoq, $nrloteestq = NULL, $nrsublote = NULL){
		try{
			$rep = Pedido::getRepository();
			return $rep->getQtdeDisp($cdfilial, $cdproduto, $cdalmoxarife, $cdlocalestoq, $nrloteestq, $nrsublote);
		}catch(\Exception $e){
			throw $e;
		}
	}

	//Registro de Reserva do Produto
	public static function regReserva($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtresprodped, $qtresprodarr, $nrloteestq = NULL, $nrsublote = NULL, $cdlocalestoq = NULL, $cdalmoxarife = NULL){
		$nrresprodped = ReservaItem::novoCodigoReserva($nrorg, $cdfilial);
		$reserprodped = new Reserprodped();
		$reserprodped->setNrresprodped($nrresprodped);
		$reserprodped->setNrorg($nrorg);
		$reserprodped->setCdfilial($cdfilial);
		$reserprodped->setCdproduto($cdproduto);
		$reserprodped->setNrpedido($nrpedido);
		$reserprodped->setNritemped($nritemped);
		$reserprodped->setQtresprodped($qtresprodped);
		$reserprodped->setQtresprodarr($qtresprodarr);
		$reserprodped->setNrloteestq($nrloteestq);											
		$reserprodped->setNrsublote($nrsublote);	
		$reserprodped->setCdlocalestoq($cdlocalestoq);	
		$reserprodped->setCdalmoxarife($cdalmoxarife);	
		$reserprodped->setDtultatu(DateUtil::getDataAtual());
		$reserprodped->setDtinclusao(DateUtil::getDataAtual());
		$reserprodped->setCdoperinclusao(Ambiente::getCdoperador());
		$reserprodped->setCdoperultatu(Ambiente::getCdoperador());
		$reserprodped->persist();
		Registry::getEntityManager()->flush();
	}

	//Reserva Produto
	public static function reserProd($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtdedisp, $qtitemped, $testaest = FALSE, $vrfatoconv = 1){
		if($testaest){
			//Rotina de Reserva COM Teste de Estoque
			if($qtdedisp){
				$qtdisponivel = 0;
				foreach($qtdedisp as $qtdisp){
					$qtdisponivel = $qtdisponivel + $qtdisp['QTDISPONIVEL'];
				}
				if($qtdisponivel >= $qtitemped){
					ReservaItem::paramRegReserva($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtdedisp, $qtitemped);
				}else return 'Quantidade Indisponível para Reserva. Quantidade Disponível: '.number_format($qtdisponivel/$vrfatoconv, 4, ',','.');
			}else return 'Quantidade Indisponível para Reserva. Quantidade Disponível: 0,0000';
		}else{
			//Rotina de Reserva SEM Teste de Estoque
			if($qtdedisp){
				$qtitemped = ReservaItem::paramRegReserva($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtdedisp, $qtitemped);
				if($qtitemped > 0){
					//Reserva a Quantidade do Produto SEM Lote
					ReservaItem::regReserva($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtitemped, $qtitemped);
				}
			}else{
				//Reserva a Quantidade do Produto SEM Lote
				ReservaItem::regReserva($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtitemped, $qtitemped);
			}
		}
	}
	
	//Parametros de Registro para Reserva
	public static function paramRegReserva($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtdedisp, $qtitemped){
		foreach($qtdedisp as $qtdisp){
			$cdalmoxarife = $qtdisp['CDALMOXARIFE'];
			$cdlocalestoq = $qtdisp['CDLOCALESTOQ'];
			$nrloteestq   = $qtdisp['NRLOTEESTQ'];
			$nrsublote    = $qtdisp['NRSUBLOTE'];
			$qtdisponivel = $qtdisp['QTDISPONIVEL'];
			if($qtdisponivel > 0){
				if($qtdisponivel >= $qtitemped){
					  $qtresprodped = $qtitemped;
				}else $qtresprodped = $qtdisponivel;
				ReservaItem::regReserva($nrorg, $cdfilial, $cdproduto, $nrpedido, $nritemped, $qtresprodped, $qtresprodped, $nrloteestq, $nrsublote, $cdlocalestoq, $cdalmoxarife);
				$qtitemped = $qtitemped - $qtresprodped;
			}
		}
		return $qtitemped;
	}
	
}